"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _bind = _interopRequireDefault(require("classnames/bind"));
var _terraButton = _interopRequireDefault(require("terra-button"));
var _IconChevronRight = _interopRequireDefault(require("terra-icon/lib/icon/IconChevronRight"));
var _terraToggle = _interopRequireDefault(require("terra-toggle"));
var _ToggleButtonModule = _interopRequireDefault(require("./ToggleButton.module.scss"));
var _excluded = ["buttonAttrs", "children", "closedButtonText", "icon", "isAnimated", "isIconAnimated", "isIconOnly", "isInitiallyOpen", "onClose", "onOpen", "openedButtonText"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
var cx = _bind.default.bind(_ToggleButtonModule.default);
var propTypes = {
  /**
   * Content in the body of the toggle-button component that will be expanded or toggle-buttond
   */
  children: _propTypes.default.node.isRequired,
  /**
   * Sets the text inside of the button when the toggle-button component is closed
   */
  closedButtonText: _propTypes.default.string.isRequired,
  /**
   * Used to set props and HTML attributes on the toggle-button button
   */
  // eslint-disable-next-line react/forbid-prop-types
  buttonAttrs: _propTypes.default.object,
  /**
   * Icon displayed next to text content within the toggle-button button
   */
  icon: _propTypes.default.element,
  /**
   * Sets the toggle-button to be animated when it is opened or closed
   */
  isAnimated: _propTypes.default.bool,
  /**
   * Used to turn on animation on toggle-button button icon
   */
  isIconAnimated: _propTypes.default.bool,
  /**
   * Sets the toggle-button to only display and icon. Uses closedButtonText prop as an aria-label on the button.
   */
  isIconOnly: _propTypes.default.bool,
  /**
   * Sets the toggle-button initial state to open
   */
  isInitiallyOpen: _propTypes.default.bool,
  /**
   * Callback function triggered when toggle-button is closed
   */
  onClose: _propTypes.default.func,
  /**
   * Callback function triggered when toggle-button is opened
   */
  onOpen: _propTypes.default.func,
  /**
   * Sets the text inside of the button when the toggle-button component is open
   */
  openedButtonText: _propTypes.default.string
};
var defaultProps = {
  isAnimated: false,
  isIconAnimated: false,
  isIconOnly: false,
  isInitiallyOpen: false,
  icon: /*#__PURE__*/_react.default.createElement(_IconChevronRight.default, null)
};
var ToggleButton = /*#__PURE__*/function (_React$Component) {
  function ToggleButton(props) {
    var _this;
    _classCallCheck(this, ToggleButton);
    _this = _callSuper(this, ToggleButton, [props]);
    _this.state = {
      isOpen: props.isInitiallyOpen
    };
    _this.handleOnClick = _this.handleOnClick.bind(_this);
    return _this;
  }
  _inherits(ToggleButton, _React$Component);
  return _createClass(ToggleButton, [{
    key: "handleOnClick",
    value: function handleOnClick(e) {
      e.preventDefault();

      // Fire event from toggle handlers
      if (!this.state.isOpen && this.props.onOpen) {
        this.props.onOpen();
      } else if (this.state.isOpen && this.props.onClose) {
        this.props.onClose();
      }
      this.setState(function (prevState) {
        return {
          isOpen: !prevState.isOpen
        };
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        buttonAttrs = _this$props.buttonAttrs,
        children = _this$props.children,
        closedButtonText = _this$props.closedButtonText,
        icon = _this$props.icon,
        isAnimated = _this$props.isAnimated,
        isIconAnimated = _this$props.isIconAnimated,
        isIconOnly = _this$props.isIconOnly,
        isInitiallyOpen = _this$props.isInitiallyOpen,
        onClose = _this$props.onClose,
        onOpen = _this$props.onOpen,
        openedButtonText = _this$props.openedButtonText,
        customProps = _objectWithoutProperties(_this$props, _excluded);
      // Set openHeaderText to the same value as closedHeaderText if its not already set
      var normalizedOpenButtonText = openedButtonText || closedButtonText;
      var buttonText = !this.state.isOpen ? closedButtonText : normalizedOpenButtonText;
      var text = isIconOnly ? closedButtonText : buttonText;
      var toggleButtonClass = cx(['button', {
        'is-open': this.state.isOpen
      }, {
        'is-icon-animated': isIconAnimated
      }, customProps.className]);
      var button = /*#__PURE__*/_react.default.createElement(_terraButton.default, _extends({}, buttonAttrs, {
        isIconOnly: isIconOnly,
        icon: /*#__PURE__*/_react.default.createElement("span", {
          className: cx('icon')
        }, icon),
        "aria-expanded": this.state.isOpen,
        text: text,
        onClick: this.handleOnClick
      }));
      return /*#__PURE__*/_react.default.createElement("div", _extends({}, customProps, {
        className: toggleButtonClass
      }), button, /*#__PURE__*/_react.default.createElement(_terraToggle.default, {
        isOpen: this.state.isOpen,
        isAnimated: this.props.isAnimated
      }, this.props.children));
    }
  }]);
}(_react.default.Component);
ToggleButton.propTypes = propTypes;
ToggleButton.defaultProps = defaultProps;
var _default = exports.default = ToggleButton;